//.data
.text

.global main

main:        
         push    {r0-r12,lr}
         bl      cls // On efface l'écran
         // On lit la chaine de caractères à afficher
         ldr     r0,=texte
lirecar: ldrb    r1,[r0],#1  // On lit un octet et on incrémente le compteur
         cmp     r1,#0 // On arrête de traiter la chaine à afficher au terminateur
         beq     arret
         // On détermine les coordonnées de ce caractère
         bl      coord
         // r1=caractère, r2=Y, r3=X, r4=return status
         cmp     r4,#0 // analyse du return status
         bne     arret // arret si différent de 0
         // r1=caractère, r2=Y, r3=X
         bl      trt_car
         add     r3,#1 // et X est incrémenté
         ldr     r4,=pos
         strb    r2,[r4],#1 // On sauvegarde Y
         strb    r3,[r4]    // On sauvegarde X
         b       lirecar
arret:   bl      PAUSE // On reste avec l'écran rempli un moment
         pop     {r0-r12,pc} // Fin du programme
//----------------------------------------------------------------------------
         // On détermine les coordonnées de ce caractère
coord:   push    {r0,lr}
         ldr     r0,=pos
         ldrb    r2,[r0],#1 // Y
         ldrb    r3,[r0]    // X
         cmp     r3,#40
         bgt     trunc // si X > 40
         cmp     r2,#24
         bgt     trunc // si Y > 24
         mov     r4,#0
         b       ret
trunc:   mov     r4,#1
ret:     pop     {r0,pc}
//----------------------------------------------------------------------------
trt_car: push    {r0-r12,lr}
         // On récupère l'@ du buffer écran
         mov     r9,#0xC0000010
         ldr     r9,[r9]
         // On ajoute le décalage dû aux coordonnées
         sub     r2,#1
         mov     r5,#20
         mul     r2,r5 // (Y-1)*20
         sub     r3,#1
         mov     r5,#3840
         mul     r3,r5 // (X-1)*3840
         add     r5,r2,r3
         add     r9,r5 // @définitive du caractère. Point en haut, à gauche
         // On affiche le caractère
         ldr     r5,=police
         mov     r2,#10
         mul     r0,r1,r2 // Chaque caractère est représenté sur 10 octets dans la table des caratères
         add     r4,r5,r0 // On détermine l'adresse, dans la table, du caractère à afficher
         bl      disp_chr
         pop     {r0-r12,pc}
//----------------------------------------------------------------------------
// Sous-programme d'affichage d'un caractère
disp_chr:push    {r3-r8,lr}
         mov     r5,#-1 // indice de ligne dans le caractère
ligchar: add     r5,#1
         ldrb    r3,[r4]
         // On traite la ligne de caractère
         //-----------------------------------------------------------------------------
         mov     r8,#0 // indice de colonne de caractère dans la ligne traitée
         lsl     r3,#24 // On décale l'octet vers la gauche
colchar: lsls    r3,r3,#1 // On vérifie si le bit est à 0 ou à 1
         bcs     allumer
         ldr     r7,=colors
         ldrh    r6,[r7] // On récupère la couleur du fond car pixel éteint
         bl      display
         b       suite
allumer: ldr     r7,=colors
         ldrh    r6,[r7,#2] // On récupère la couleur du pixel allumé
         bl      display
suite:   add     r8,#1
         cmp     r8,#7 // Le caractère fait 8 colonnes (pixels) de large
         ble     colchar
         //----------------------------------------------------------------------------
         add     r4,#1
         cmp     r5,#9 // le caractère fait 10 lignes (pixels) de haut
         blt     ligchar
         pop     {r3-r8,pc}
//----------------------------------------------------------------------------
// Sous-programme d'affichage physique d'un pixel
display: push    {r0-r3,lr}
         mov     r3,#480 // @pixel=(num col * 480) + (num lig * 2)
         mul     r1,r8,r3
         mov     r3,#2
         mul     r2,r5,r3
         add     r1,r1,r2
         add     r1,r1,r9 // On ajoute l'@ du buffer écran
         strh    r6,[r1]
         pop     {r0-r3,pc}
//----------------------------------------------------------------------------
// Sous-programme d'effacement de l'écran
cls:     push    {r0-r2,lr}
         mov     r0,#0xC0000010 //Frame Base Address. Holds the address of pixels
         ldr     r0,[r0]
         mov     r1,#0
         mov     r2,#38400
clr_lp:  str     r1,[r0],#4
         subs    r2,#1
         bne     clr_lp
         pop     {r0-r2,pc}
//----------------------------------------------------------------------------
// Sous-programmes de temporisation (durée fixe actuellement)
PAUSE:   push    {r0,lr}
         mov     r0,#0x40000000 /* durée de l'attente. Environ 15 sec sur émulateur */
waitlp:  subs    r0,#1
         bne     waitlp
         pop     {r0,pc}

pos:    .byte 12,15 // position ligne (Y) colonne (X). 24 lignes x 40 colonnes
colors: .hword 0xFFDE,0xC0A2 // backgroud, foreground colors 0x3435,0xCBCA
//colors: .hword 0x247C,0xFFFF // backgroud, foreground colors 0x3435,0xCBCA
//colors: .hword 0x0000,0xffff // backgroud, foreground colors 0x3435,0xCBCA
//colors: .hword 0x0000,0x14A2 // backgroud, foreground colors 0x3435,0xCBCA
//texte:  .asciz "!\"#$%&'()*+,-./:;<=>?@[\\]^_\`{|}~"
//texte:  .asciz "abcdefghijklmnopqrstuvwxyz"
//texte:  .asciz "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
//texte:  .asciz "0123456789"
texte:  .asciz "Hello World!"

police:
        .include "police.dat"
